#include <stdio.h>
#include <sys/types.h>
#include "gen.h"
#ifndef STANDARD
#include <zstand.h>
#endif

long bsizefd(FD in, Stat * sstat)
	{
	long rtn = BUFSIZ;
	
#ifdef bsd	
	if (sstat != NULL)
		rtn = sstat->st_blksize;
	else
		{
		Stat sstat;
		if (0 <= fstat(in, &sstat))
			rtn = sstat.st_blksize;
#else		
		Statfs sstatfs;
		if (0 <= fstatfs(in, &sstatfs))
			rtn = sstatfs.f_bsize;
#endif		
#ifdef bsd
		}
#endif		
	return rtn;
	}

long bsizename(char * name, Stat * sstat)
	{
	long rtn = BUFSIZ;
#if defined(bsd) || defined(linux)
	if (sstat != NULL)
		rtn = sstat->st_blksize;
	else
		{
		Stat sstat;
		if (0 <= stat(name, &sstat))
			rtn = sstat.st_blksize;
#else		
		Statfs sstatfs;
		
		if (0 <= statfs(name, &sstatfs))
			rtn = sstatfs.f_bsize;
#endif		
#if defined(bsd) || defined(linux)
		}
#endif	
	return rtn;
	}

long bcount(Stat * sstat, long blsize)
	{
	long rtn;
#if defined(bsd) || defined(linux)
	rtn = sstat->st_blocks;
#else
	rtn = howmany(sstat->sstat.st_size, blsize);
#endif	
	return rtn;
	}

long brepsize(char *name, Stat * sstat)
	{
	long rtn = 512;
#if !defined(bsd) && !defined(linux)
	Statfs statfs;
	if (0 <= statfs(name, &sstatfs))
		rtn = sstatfs.f_bsize;
#endif	
	return rtn;
	}

